Subject: Protocol Versioning [was: Re: I-D ACTION:draft-ietf-sacred-protocol-bss-01.txt]

From: "Gareth Richards" <[email-masked]>
Date: Tue, 5 Feb 2002 12:18:56 -0000

Stephen,

None of the PDUs described in the current ID contain version information.
I suggest that this may be needed to support future version of SACRED.

I was also wondering if it might be worth placing these attributes and any
other information common to all message types in abstract base types
similar to the RequestAbstractType and ResultAbstract type of XKMS as this
may make the schema simpler.

For example,

  <complexType name="RequestAbstractType" abstract="true">
    <sequence>
      <element ref="sacred:ProcessInfo" minOccurs="0"/>
    </sequence>
    <attribute name="MajorVersion" type="nonNegativeInteger" use="required"
fixed="1"/>
    <attribute name="MinorVersion" type="nonNegativeInteger" use="required"
fixed="0"/>
  </complexType>

   <complexType name="ResponseAbstractType" abstract="true">
    <sequence>
       <element name="Status" type="string" minOccurs="0"/>
    </sequence>
    <attribute name="MajorVersion" type="nonNegativeInteger" use="required"
fixed="1"/>
    <attribute name="MinorVersion" type="nonNegativeInteger" use="required"
fixed="0"/>
  </complexType>

There are a couple of other issues related to schema.

I noticed that you added XML complexity as a major open issue.  Could you
expand on this.

Do we really need to maintain a DTD and a schema? Since it is possible to
generate a DTD from a schema then wouldn't a schema be sufficient? It seems
as is not just unnecessary but also potentially harmful due to possible
discrepancies.

---

From: Stephen Farrell <[email-masked]>
Date: Tue, 05 Feb 2002 12:32:36 +0000

Gareth,

'Fraid I at least don't like these suggested changes!

For versioning - there's already a namespace & beep profile, what 
more's needed?

I'd also rather not start using abtract types in the schema since
I don't see much saving and in any case, I noted an open issue in
the draft (whether DTD or schema should be normative) that should
be closed before we try using (what I think is) fancy schema stuff.

Finally, I note that the DTD automatically generated from schema that
my tool produces is total garbarge and drags in all sorts of dsig
stuff, has a lot of repetition etc. So no, I don't think a schema
is sufficient is there's a set of folks who prefer DTDs. Another
reason for us to first decide which (DTD/schema) to make normative.

Stephen.

-- 
____________________________________________________________
Stephen Farrell         				   
Baltimore Technologies,   tel: (direct line) +353 1 881 6716
39 Parkgate Street,                     fax: +353 1 881 7000
Dublin 8.                mailto:[email-masked]
Ireland                             http://www.baltimore.com